package com.zipcodewilmington.arrayutility;

import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.stream.Stream;

/**
 * Created by leon on 3/6/18.
 */
public class ArrayUtility <T>{
    private ArrayList <T> list;
    private T [] array;

    public ArrayUtility(T[] array){
        this.list= new ArrayList<T>(Arrays.asList(array));
        this.array=array;
    }

    public void merge (T[] arrayToMerge){
        for (T i : arrayToMerge){
            list.add(i);
        }
}



    public Integer countDuplicatesInMerge(T [] arrayToMerge, T valueToEvaluate) {
        merge(arrayToMerge);
        int counter = getNumberOfOccurrences(valueToEvaluate);
            return counter;
    }

    public T getMostCommonFromMerge(T [] arrayToMerge) {
        merge(arrayToMerge);
        T mostCommon = null;
        int counter = 0;
        for (T num:list) {
            if (getNumberOfOccurrences(num)> counter){
                counter = getNumberOfOccurrences(num);
                mostCommon = num;
            }

        }



        return mostCommon;
    }


    public int getNumberOfOccurrences(T valueToEvaluate) {
    int counter = 0;
    for (T index : list ){
        if (index.equals(valueToEvaluate)){
            counter++;
        }
    }
    return counter;
    }

    public T [] removeValue(T valueToRemove) {

        ArrayList <T> temp = new ArrayList<>();
       //  T [] tempARR= new T [temp.size()];
        for (T counter:list) {
            if (!counter.equals(valueToRemove)){
                temp.add(counter);
            }

        }
        int stretch = temp.size();
        T [] tempARR = (T[]) Array.newInstance
                (array.getClass().getComponentType(), stretch);

        return temp.toArray(tempARR);
    }
}
